/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;



public class DialSerializer implements JsonSerializer<DIAL> {

  @Override
  public JsonElement serialize(DIAL dial, Type type, JsonSerializationContext context) {

    JsonObject jsonObject = new JsonObject();

    JsonObject dataset = new JsonObject();
    dataset.add(DIAL.CALLER_NICKNAME, context.serialize(dial.getCallerNickname()));
    dataset.add(DIAL.CALLER_SESSION, context.serialize(dial.getCallerSession()));
    dataset.add(DIAL.CALLER_PSEUDOID, context.serialize(dial.getCallerPseudoid()));
    dataset.add(DIAL.CALLER_VOICE, context.serialize(dial.getCallerVoice()));
    dataset.add(DIAL.RECEIVER_IP, context.serialize(dial.getReceiverIp()));
    dataset.add(DIAL.RECEIVER_NICKNAME, context.serialize(dial.getReceiverNickname()));
    dataset.add(DIAL.RECEIVER_PORT, context.serialize(dial.getReceiverPort()));
    dataset.add(DIAL.RECEIVER_SESSION, context.serialize(dial.getReceiverSession()));
    dataset.add(DIAL.RECEIVER_PSEUDOID, context.serialize(dial.getReceiverPseudoid()));
    dataset.add(DIAL.ERRORCODE, context.serialize(dial.getErrorCode()));
    dataset.add(DIAL.ERRORMESSAGE, context.serialize(dial.getErrorMessage()));
    dataset.add(DIAL.MULTILINGUALKEY, context.serialize(dial.getMultilingualkey()));
    dataset.add(DIAL.TEXT, context.serialize(dial.getText()));

    jsonObject.add("HEADER", context.serialize(dial.getHeader()));
    jsonObject.add("COMMAND", context.serialize(dial.getCommand()));
    jsonObject.add("DATASET", context.serialize(dataset));

    return jsonObject;

  }

}
